# Move armor stands every 3 ticks - their update rate:
# https://www.reddit.com/r/Minecraft/comments/53hkkc/111_growth_chance_calculator/d7tovh8/
scoreboard players add @s RAFTMoveTimer 1
execute @s[score_RAFTMoveTimer_min=3] ~ ~ ~ function raft:move_entities if @e[type=armor_stand,score_RAFTDirection_min=1]
# Also kill any shulkers that have taken enough damage
execute @s[score_RAFTMoveTimer_min=3] ~ ~ ~ scoreboard players tag @e[type=shulker,tag=RAFTBlock] add RAFTDead {AbsorptionAmount:0.0f}
execute @s[score_RAFTMoveTimer_min=3] ~ ~ ~ execute @e[type=shulker,tag=RAFTDead] ~ ~ ~ function raft:block_destroy
scoreboard players set @s[score_RAFTMoveTimer_min=3] RAFTMoveTimer 0

# Cannonball effects
execute @e[tag=GAMECannonball] ~ ~ ~ function phase_play:cannonball
# Arrow effects
execute @e[type=arrow] ~ ~ ~ function phase_play:arrow

# Per player stuff
execute @a[m=!spectator] ~ ~ ~ function phase_play:per_player

# Move players, keep minecart synced (weird desync stuff fix)
scoreboard players add @s PlayerMoveCycle 1

execute @s[score_PlayerMoveCycle=20,score_PlayerMoveCycle_min=1] ~ ~ ~ function raft:move_all_players if @e[type=armor_stand,score_RAFTDirection_min=1]
scoreboard players set @s[score_PlayerMoveCycle_min=21] PlayerMoveCycle -1
execute @s[score_PlayerMoveCycle_min=1,score_PlayerMoveCycle=1] ~ ~ ~ function raft:move_all_players if @e[type=armor_stand,score_RAFTDirection_min=1]
execute @s[score_PlayerMoveCycle_min=1,score_PlayerMoveCycle=1] ~ ~ ~ function raft:move_all_players if @e[type=armor_stand,score_RAFTDirection_min=1]

execute @s[score_PlayerMoveCycle_min=5,score_PlayerMoveCycle=5] ~ ~ ~ entitydata @e[type=area_effect_cloud,tag=RAFTHelmCloud] {Air:0s}
execute @s[score_PlayerMoveCycle_min=15,score_PlayerMoveCycle=15] ~ ~ ~ entitydata @e[type=area_effect_cloud,tag=RAFTHelmCloud] {Air:1s}

# AI: Check for falling stuff, load entire raft
scoreboard players add @s[tag=AI] AICheckTimer 1
execute @s[tag=AI,score_AICheckTimer_min=61] ~ ~ ~ execute @e[type=armor_stand,tag=AIGame] ~ ~ ~ function ai:main_play_slow
scoreboard players set @s[tag=AI,score_AICheckTimer_min=61] AICheckTimer 0
# AI: Load self and move
scoreboard players add @s[tag=AI] AIMoveTimer 1
execute @s[tag=AI,score_AIMoveTimer_min=30] ~ ~ ~ execute @e[type=armor_stand,tag=AIGame] ~ ~ ~ function ai:main_play
scoreboard players set @s[tag=AI,score_AIMoveTimer_min=30] AIMoveTimer 0
# AI: Fire any projectiles that are on-target
scoreboard players add @s[tag=AI] AIShootTimer 1
execute @s[tag=AI,score_AIShootTimer_min=20] ~ ~ ~ execute @e[tag=AITarget] ~-1 ~-5 ~-1 execute @e[type=area_effect_cloud,tag=AIProjectileArc,dx=2,dy=10,dz=2] ~ ~ ~ function ai:arc_on_target
scoreboard players set @s[tag=AI,score_AIShootTimer_min=20] AIShootTimer 0

# Random items
scoreboard players add @s ItemTimer 1
execute @s[score_ItemTimer_min=30] ~ ~ ~ function phase_play:random_item

# Check chests valid (not inside blocks), kill stuff going outside arena
scoreboard players add @s ValidityTimer 1
execute @s[score_ValidityTimer_min=40] ~ ~ ~ function phase_play:validity_check

# Check win
scoreboard players add @s WinCheckTimer 1
execute @s[score_WinCheckTimer_min=40,tag=!AI] ~ ~ ~ function phase_play:win_check
execute @s[score_WinCheckTimer_min=40,tag=AI] ~ ~ ~ function phase_play:win_check_ai